#ifdef	EXERCISE3

#include "servant.h"

CONST_INTEGER	DAYS_PER_YEAR	= 365;
CONST_INTEGER	MONTHS_PER_YEAR = 12;
CONST_INTEGER	DAYS_PER_WEEK	= 7;
CONST_INTEGER	START_YEAR		= 1900;

//////////////////////////////////////////////////////

FUNCTION(BOOLEAN) IsLeapYear ARGUMENTS (INTEGER y)
BEGIN
	RESULT((y % 400 EQUAL 0) OR ((y % 4 EQUAL 0) AND  (y % 100 DIFFERENT 0)));
END

//////////////////////////////////////////////////////

FUNCTION(INTEGER) LeapYearsUntil (INTEGER year)
BEGIN
	INTEGER n = 0, i;
	FOR i = START_YEAR; i <= year; i = i+1 DO
		IF IsLeapYear(i) EQUAL TRUE THEN
			n = n + 1;
	RESULT(n);
END

//////////////////////////////////////////////////////

ARRAY(INTEGER, MONTHS_PER_YEAR) daysPerMonth;

PROCEDURE InitialiseDaysPerMonth ARGUMENTS (ADDRESSEX(INTEGER) p)
BEGIN
	p[0] = p[2] = p[4] = p[6] = p[7] = p[9] = p[11] = 31;
	p[1] = 28;
	p[3] = p[5] = p[8] = p[10] = 30;
END

//////////////////////////////////////////////////////

FUNCTION(INTEGER) DaysTillDate ARGUMENTS (INTEGER year, INTEGER month, INTEGER dayInMonth)
BEGIN
	INTEGER daysSum = dayInMonth, i;

	FOR i = 0; i < month ; i = i + 1 DO
	BEGIN
		daysSum = daysSum + daysPerMonth[i];
		IF i EQUAL 1 AND IsLeapYear(year) EQUAL TRUE THEN
			daysSum = daysSum + 1;
	END

	RESULT((year-1) * DAYS_PER_YEAR + LeapYearsUntil(year-1) + daysSum);
END

//////////////////////////////////////////////////////

FUNCTION(INTEGER) GetDayOfTheWeek (INTEGER year, INTEGER month, INTEGER dayInMonth) 
BEGIN
	INTEGER daysTillCurrDate = DaysTillDate(curr_year(), curr_month(), curr_date());
	INTEGER daysTillThatDate = DaysTillDate(year, month, dayInMonth);

	IF daysTillCurrDate > daysTillThatDate THEN
		RESULT((curr_day() + 7 - (daysTillCurrDate - daysTillThatDate) % 7) % 7);
	ELSE
	IF daysTillCurrDate < daysTillThatDate THEN
		RESULT((curr_day() + (daysTillThatDate - daysTillCurrDate) % 7) % 7);
	ELSE	
		RESULT(curr_day());	 
END

//////////////////////////////////////////////////////

ARRAY(STRING, DAYS_PER_WEEK) dayNames;

PROCEDURE InitialiseDayNames ARGUMENTS (ADDRESSEX(STRING) p) 
BEGIN
	p[0] = "Sun";
	p[1] = "Mon";
	p[2] = "Tue";
	p[3] = "Wed";
	p[4] = "Thu";
	p[5] = "Fri";
	p[6] = "Sat";
END

//////////////////////////////////////////////////////

ARRAY(STRING, MONTHS_PER_YEAR) monthNames;

PROCEDURE InitialiseMonthNames ARGUMENTS (ADDRESSEX(STRING) p) 
BEGIN
	p[0] = "January";
	p[1] = "February";
	p[2] = "March";
	p[3] = "April";
	p[4] = "May";
	p[5] = "June";
	p[6] = "July";
	p[7] = "August";
	p[8] = "September";
	p[9] = "October";
	p[10] = "November";
	p[11] = "December";
END

//////////////////////////////////////////////////////

PROCEDURE PrintMonthCalendar ARGUMENTS (INTEGER year, INTEGER month)
BEGIN
	INTEGER firstDay	= GetDayOfTheWeek(year, month, 1);
	INTEGER daysOfMonth = daysPerMonth[month];
	INTEGER i;
	INTEGER displayed;

	IF month EQUAL 1 AND IsLeapYear(year) EQUAL TRUE THEN
		daysOfMonth = daysOfMonth + 1;

	CTRL_OUTPUTEX_INTEGER(3);
	CTRL_OUTPUTEX_STRING(FALSE);

	OUTPUTEX("Callendar for "); 
	OUTPUTEX(monthNames[month]); 
	OUTPUTEX(" of year "); 
	OUTPUTEX(year); 
	
	OUTPUTEX(LINE);
	OUTPUTEX("Sun Mon Tue Wed Thu Fri Sat");
	OUTPUTEX(LINE);

	FOR displayed = 0; displayed < firstDay; displayed = displayed + 1 DO
		OUTPUTEX("    ");

	FOR i = 0; i < daysOfMonth; i = i+1 DO
	BEGIN
			IF displayed % DAYS_PER_WEEK EQUAL 0 THEN
				OUTPUTEX(LINE);

			OUTPUTEX(i+1); OUTPUTEX(" ");

			IF firstDay EQUAL 6 THEN
				firstDay = 0;
			ELSE
				firstDay = firstDay+1;

			displayed = displayed + 1;
	END

	OUTPUTEX(LINE);
END

//////////////////////////////////////////////////////

FUNCTION(INTEGER) InputYear ARGUMENTS ()
BEGIN
	INTEGER y;
	OUTPUTEX("Year:"); 
	INPUTEX(y);

	IF y < START_YEAR THEN
	BEGIN
		OUTPUTEX("Year should be >= 1900!"); 
		OUTPUTEX(LINE);
		RESULT(0);
	END
	ELSE
		RESULT(y);
END

//////////////////////////////////////////////////////

FUNCTION(INTEGER) InputMonth ARGUMENTS ()
BEGIN
	INTEGER m;
	OUTPUTEX("Month:"); 
	INPUTEX(m);

	IF m <= 0 OR m > MONTHS_PER_YEAR THEN
	BEGIN
		OUTPUTEX("Month should be in [1, 12]!"); 
		OUTPUTEX(LINE);
		RESULT(0);
	END
	ELSE
		RESULT(m);
END

//////////////////////////////////////////////////////

PROGRAM_BEGIN

	InitialiseDayNames(dayNames);
	InitialiseDaysPerMonth(daysPerMonth);
	InitialiseMonthNames(monthNames);

	INTEGER y = InputYear();
	IF y EQUAL 0 THEN
		STOP;

	INTEGER m = InputMonth();
	IF m EQUAL 0 THEN
		STOP;

	PrintMonthCalendar(y, m-1);
PROGRAM_END

//////////////////////////////////////////////////////

#endif

